#define __IO
#define __I

typedef struct {
       //uint8_t RESERVED_0[256];
  __IO uint32_t ICCICR;          // CPU Interface Control Register, offset: 0x100
  __IO uint32_t ICCPMR;          // Interrupt Priority Mask Register, offset: 0x104
  __IO uint32_t ICCBPR;          // Binary Point Register, offset: 0x108
  __IO uint32_t ICCIAR;          // Interrupt Acknowledge Register, offset: 0x10C
  __IO uint32_t ICCEOIR;         // End of Interrupt Register, offset: 0x110
  __IO uint32_t ICCRPR;          // Running Priority Register, offset: 0x114
  __IO uint32_t ICCHPIR;         // Highest Pending Interrupt Register, offset: 0x118
  __IO uint32_t ICCABPR;         // Aliased Binary Point Register, offset: 0x11C
       uint8_t RESERVED_1[3808];
  __IO uint32_t ICDDCR;          // Distributor Control Register, offset: 0x1000
       uint32_t ICDICTR;
       uint32_t ICDIIDR;
       uint8_t RESERVED_2[116];
  __IO uint32_t ICDISR[5];       // Interrupt Security Register 0..4, offset: 0x1080
       uint8_t RESERVED_3[108];
 __IO uint32_t ICDISER[5];       // Interrupt Set-Enable Register 0..4, offset: 0x1100
       uint8_t RESERVED_4[108];
  __IO uint32_t ICDICER[5];      // Interrupt Clear-Enable Register 0..4, offset: 0x1180
       uint8_t RESERVED_5[108];
  __IO uint32_t ICDISPR[5];      // Interrupt Set-Pending Register 0..4, offset: 0x1200
       uint8_t RESERVED_6[108];
  __IO uint32_t ICDICPR[5];      // Interrupt Security Register 0..4, offset: 0x1280
       uint8_t RESERVED_7[108];
  __IO uint32_t ICDABR[5];       // Active Bit Register 0..4, offset: 0x1300
       uint8_t RESERVED_8[236];
  __IO uint32_t ICDIPR[36];      // Interrupt Priority Register 0..35, offset: 0x1400
       uint8_t RESERVED_9[880];
  __IO uint32_t ICDIPTR[36];     // Interrupt Processor Targets Register 0..35, offset: 0x1800
       uint8_t RESERVED_10[880];
  __IO uint32_t ICDICFR[9];      // Interrupt Configuration Register 0..8, offset: 0x1C00
       uint8_t RESERVED_11[220];
  __I  uint32_t ICPPISR;         // Private Peripheral Interrupt Status Register, offset: 0x1D00
  __IO uint32_t ICSPISR[5];      // Shared Peripheral Interrupt Status Register 0..4, offset: 0x1D04
       uint8_t RESERVED_12[488];
  __IO uint32_t ICDSGIR[1];      // Software Generated Interrupt Register, offset: 0x1F00
} GIC_Type;

#define GIC ((volatile GIC_Type *)(XPAR_SCUGIC_0_CPU_BASEADDR))

